package cn.iocoder.yudao.module.mes.service.repairtems;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.module.mes.controller.admin.repairtems.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.criticalcomponent.CriticalComponentDO;
import cn.iocoder.yudao.module.mes.dal.dataobject.deviceledger.DeviceLedgerDO;
import cn.iocoder.yudao.module.mes.dal.dataobject.repairtems.RepairTemsDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;

/**
 * 维修项目 Service 接口
 *
 * @author 内蒙必硕
 */
public interface RepairTemsService {

    /**
     * 创建维修项目
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createRepairTems(@Valid RepairTemsSaveReqVO createReqVO);

    /**
     * 更新维修项目
     *
     * @param updateReqVO 更新信息
     */
    void updateRepairTems(@Valid RepairTemsSaveReqVO updateReqVO);

    /**
     * 删除维修项目
     *
     * @param id 编号
     */
    void deleteRepairTems( List<Long> idList);

    /**
     * 获得维修项目
     *
     * @param id 编号
     * @return 维修项目
     */
    RepairTemsDO getRepairTems(Long id);

    /**
     * 获得维修项目分页
     *
     * @param pageReqVO 分页查询
     * @return 维修项目分页
     */
    PageResult<RepairTemsRespVO> getRepairTemsPage(RepairTemsPageReqVO pageReqVO);

    List<RepairTemsRespVO> getDeviceOrComponent(Integer deviceType);

    List<RepairTemsRespVO> getDeviceOrComponentList(Long deviceId, Long componentId);

    List<CriticalComponentDO> getComponentList(Long deviceId);
}